@echo off
SETLOCAL ENABLEDELAYEDEXPANSION
TITLE Far Cry 4 MapSwapper DNS Server
If not exist "%~dp0lib\DualServer.exe" goto :ERROR
for /f "delims=[] tokens=2" %%a in ('ping -4 -n 1 %ComputerName% ^| findstr [') do set NETWORKIP=%%a
cd /D "%~dp0lib"
CLS

if NOT "%~1"=="fixdynamic" (

rem 	echo Far Cry 4 MapSwapper DNS Server by Steve64 ^(http://steve.farcry.eu/^)
rem 	echo ---------------------------------------------------------------------
rem 	echo.
rem 	echo The Far Cry 4 MapSwapper allows you to download maps from other platforms.
rem 	echo This works natively on Windows PC's using the MapSwapper application, but 
rem 	echo for console systems, the procedure is a bit different.
rem 	echo.
rem 	echo To try the MapSwapper feature on console, you will need to:
rem 	echo.
rem 	echo 1^) Configure a Windows PC as DNS server to redirect FC4 map download requests.
rem 	echo 2^) Set up your console to use that Windows PC as its primary DNS server.
rem 	echo.
rem 	echo This script covers both steps, configuring this PC as the DNS server, as well as
rem 	echo giving you instructions on how to configure your XBox One or Playstation 4 console.
rem 	echo.
rem 	echo.
rem 	echo Ready? Then press any key to see if we can make this work on console^! ^;-^)
rem 	echo.
rem 	echo                                                             -Steve64
rem 	echo.
rem 	@pause
	CLS
	echo.
	echo.
	echo.
	echo ----------------------------------------------------------
	echo ^| Step 1: Checking network interface for requirements... ^|
	echo ----------------------------------------------------------
	echo.
)
SET IPADDRESS=
SET GATEWAY=
SET DNSTEMP=
SET DNSSERVER1=
SET DNSSERVER2=
for /F "tokens=1,2* delims=: " %%a IN ('netsh int ipv4 show config ') do (
										SET INTERFACETEMP=%%c
										if not "!INTERFACETEMP:interface =XXX!"=="!INTERFACETEMP!" if not "!INTERFACETEMP!"=="" ( SET DET_INTERFACENAME=!INTERFACETEMP:interface =!
												SET DET_IPADDRESS=
												SET DHCP=
										)

										if "%%a"=="DHCP" (SET DHCP=%%c
												SET DHCP=!DHCP: =!
										)
										if "%%a"=="IP" (	SET DET_IPADDRESS=%%c
																SET DET_IPADDRESS=!DET_IPADDRESS: =!
																IF "!DET_IPADDRESS!"=="!NETWORKIP!" SET IPADDRESS=!DET_IPADDRESS!
												)
						IF "!DET_IPADDRESS!"=="!NETWORKIP!" (
												SET INTERFACENAME=!DET_INTERFACENAME!
												IF not "_!DHCP:N=X!"=="_!DHCP!" (
													if NOT "%~1"=="fixdynamic" (	echo All OK: The Interface !INTERFACENAME! appears to be static, continuing to Step 2^^!
																	goto :RunServer
																	)
													)

												if defined DNSSERVER1	if not defined DNSSERVER2 ( SET DNSSERVER2=8.8.8.8
																			)

												if not defined DNSSERVER1 (	SET DNSTEMP=_%%c
																if not "!DNSTEMP:DNS=XXX!"=="!DNSTEMP!" (
																					 for /F "tokens=1,2* delims=: " %%h IN ('echo %%c') do (
																							SET DNSSERVER1=%%j
																							SET DNSSERVER1=!DNSSERVER1:^)=!
																							SET DNSSERVER1=!DNSSERVER1: =!
																												)
																					 SET DNSTEMP=reached
																					)

												)

												if "%%b"=="Gateway" (	SET GATEWAY=%%c
														SET GATEWAY=!GATEWAY: =!
														)
												if "%%a"=="Subnet" (	for /F "tokens=1,2* delims=: " %%h IN ('echo %%c') do (
																						SET SUBNET=%%j
																						SET SUBNET=!SUBNET:^)=!
																						SET SUBNET=!SUBNET: =!
																						)
														   )
						)
)

if "%~1"=="fixdynamic" (
	rem checking for admin permissions:
	net session >nul 2>&1
	if %errorLevel% == 0 (
		echo Setting Interface !INTERFACENAME! to DHCP...
		netsh interface ip set address name=!INTERFACENAME! source=dhcp
	) else (
		echo ERROR: You need to run this script with administrative privileges^^!
		echo ^(in Windows Explorer, right-click the script, and click `Run as Administrator'^)
	)

	goto END
)

IF NOT "!NETWORKIP!"=="!IPADDRESS!" (		echo ERROR in script: NetworkIP "!NETWORKIP!" does not match "!IPADDRESS!", aborting...
						pause
						goto :EOF
					)
if "!DNSSERVER1!"=="" ( SET DNSSERVER1=!GATEWAY!
			)

rem check if DNS server is allowed in the firewall
rem netsh advfirewall firewall show rule name="FarCry4-MapSwapper"

echo Dynamic IP address detected. But the DNS Server *requires* your IP to be STATIC.

rem checking for admin permissions:
net session >nul 2>&1
if %errorLevel% == 0 (
echo.
echo Detected Interface !INTERFACENAME!, with settings:
echo.
echo     Current IP Address:                   !IPADDRESS!
echo     Subnet mask:                          !SUBNET!
echo     Default Gateway:                      !GATEWAY!
echo     DNS Server 1:                         !DNSSERVER1!
echo     DNS Server 2:                         !DNSSERVER2!
echo.
choice /C:YN /M "Do you want to set your IP static, using the above settings "
IF ERRORLEVEL 2 goto :END
echo.
echo.
echo.
echo.
echo Attempting to set dynamic IP to static...
SET IP_MADE_STATIC=true
echo Running command: netsh interface ip set address name=!INTERFACENAME! source=static address=!IPADDRESS! mask=!SUBNET! gateway=!GATEWAY!
netsh interface ip set address name=!INTERFACENAME! source=static address=!IPADDRESS! mask=!SUBNET! gateway=!GATEWAY!
if not "!DNSSERVER1!"=="" ( echo Running command: netsh interface ip add dns name=!INTERFACENAME! address=!DNSSERVER1! validate=no
				netsh interface ip add dns name=!INTERFACENAME! address=!DNSSERVER1! validate=no
			)
if not "!DNSSERVER2!"=="" ( echo Running command: netsh interface ip add dns name=!INTERFACENAME! address=!DNSSERVER2! validate=no
				netsh interface ip add dns name=!INTERFACENAME! address=!DNSSERVER2! validate=no
			)
echo.
echo NOTE: If you want to revert back to a dynamic ^(DHCP^) IP address, run `FarCry4_MapSwapper-SET_IP-to_Dynamic.cmd` with administrator privileges
echo.
) else (
echo ERROR: The DNS server will only start if your computer has a static IP address. 
echo.
echo.
echo To resolve this, either:
echo.
echo   Manually set your IP address to static,
echo -or-
echo   Run this script with administrative privileges to attempt it automatically.
echo    ^(Meaning; in Windows Explorer, right-click this script, and click `Run as Administrator'^)
echo.
goto :END
)
echo.


:RunServer
echo.
echo.
echo.
echo ----------------------------------------------------
echo ^| Step 2^: Prepare your console for the MapSwapper: ^|
echo ----------------------------------------------------
echo.
echo On your console, enter the following:
echo.
set GATEWAY=
set SUBNET=
set DNSSERVER=
for /f "tokens=1-2 delims=:" %%a in ('ipconfig^|find "Default"') do if not defined GATEWAY set GATEWAY=%%b
for /f "tokens=1-2 delims=:" %%a in ('ipconfig^|find "Subnet"') do if not defined SUBNET set SUBNET=%%b
for /f "tokens=1-2 delims=:" %%a in ('ipconfig^|find "IPv4"') do if not defined DNSSERVER set DNSSERVER=%%b

for /f "tokens=1-4 delims=." %%a in ('echo !DNSSERVER!') do ( SET IPNET=%%a.%%b.%%c.
								call :findPS4DIGIT %%d
							)

echo         IP Address:             !IPNET!!PS4DIGIT!
echo         Subnet mask:            !SUBNET!
echo         Default Gateway:        !GATEWAY!
echo         DNS Server 1:            !IPADDRESS!
echo         DNS Server 2:            ^(leave empty^)
echo.
echo You can do that in Settings ^> Network ^> Set Up Internet Connection ^> Wifi or LAN ^> Custom
rem echo ^(XBOne^) Settings ^> Network ^> Advanced settings 
rem echo         NOTE: BEFORE YOU APPLY THE SETTINGS ON YOUR CONSOLE, FIRST PRESS ANY KEY ON HERE to start the MapSwapper DNS server.
rem echo         Otherwise, the console will nag that it doesn't have an Internet connection.
rem @pause
TIMEOUT /T 5 >nul
echo.
echo -----------------------------------------------------------------------------------
echo ^| Starting the DNS server now. To stop the server, press CTRL+C, THEN ANSWER "No" ^|
echo -----------------------------------------------------------------------------------
echo.
echo Usage instructions:
echo -------------------
echo To swap a map, visit http://maps.farcry.eu on your PC and pick a map to play.
echo Then pop into the game on console and download / play the map named `MapSwapper'.
echo.
echo.
echo Troubleshooting tips:
echo ---------------------
echo Tip 1: While the MapSwapper DNS Server is running, downloading maps from your console should
echo        produce some text here, below. If it does not, either the console's DNS settings are wrong,
echo        or your PC's firewall is blocking the DNS communication.
echo.
echo Tip 2: If in the output below you see a remark like:
echo         " Warning: [LISTEN_ON] Interface !IPADDRESS! is not static, ignored "
echo        then you will need to set your Windows PC's IP address to a static value. 
echo.
call DualServer.exe -v
TITLE
echo.
echo -----------------------------------------------------
echo ^| Server stopped. Cleaning up and exiting script... ^|
echo -----------------------------------------------------
echo.
If defined IP_MADE_STATIC ( 
echo Reverting static IP address back to DHCP now^:
echo Running command: netsh interface ip set address name=!INTERFACENAME! source=dhcp
netsh interface ip set address name=!INTERFACENAME! source=dhcp
)
GOTO END

:findPS4DIGIT
	SET PS4DIGIT=
	for /L %%a in (%1,1,255) do (
					nslookup !IPNET!%%a 2>&1 | find "***" >nul
					IF "!ERRORLEVEL!"=="0"  ( SET PS4DIGIT=%%a
								GOTO :EOF
								)
				)
goto:EOF

:ERROR
echo.
echo.
echo ERROR^^! - Please make sure you EXTRACT the FC4-MapSwapper_console zip file, and run it from the extracted folder^^!
echo.

:END
ENDLOCAL
echo Script ended.
echo.
@pause
